/****************************************************************************/
/*	Copyright (c) 2009, Bendor Research Pty. Ltd. All rights reserved.		*/
/*	This software is released under the GNU General Public License, version	*/
/*	3, with the exemptions that 1) the header files installed by this 	 	*/
/*	package can be included in closed-source code and 2) the libraries		*/
/*	built by this package can be statically linked into a closed-source 	*/
/*	binary. See the file LICENSE for the details.							*/
/*	This software is provided "AS IS", without any warranty or guarantee.	*/
/*	By using this software you acknowledge that neither Bendor Research nor	*/
/*	any of its personnel or affiliates can be held liable for any damages,	*/
/*	including, but not limited to, loss of business, loss of money, loss of */
/*	life, loss of reputation, arising out of this software being faulty or	*/
/*	not performing as advertised, even if Bendor Research was aware of such	*/
/*	faults in the software. You use this software at your own risk, any and */
/*	all liabilities that arise out of your using this software are strictly	*/
/*	yours.																	*/
/****************************************************************************/

#include <math.h>

/****************************************************************************/
/*					Public API functions									*/
/****************************************************************************/

/** @addtogroup func */
/** @{ */

/**
*	Inverse hyperbolic sine function.
*
*	@param	x			The function argument
*
*	@retval	NaN			The argument was NaN
*	@retval	INF			The argument was infinite
*	@retval	asinh(x)	Otherwise
*/

double	asinh( double x )
{
int		s;

	if ( isnan( x ) || isinf( x ) || ! x ) return( x );

	if ( x < 0 ) {

		x = fabs( x );
		s = 1;
	}
	else {

		s = 0;
	}

	if ( x > 1.79e8 )

		x = log( ldexp( x, 1 ) );
	else
		x = log( x + sqrt( x * x + 1 ) );

	return( s ? -x : +x );
}

/** @} */

